//+------------------------------------------------------------------+
//|                                                     Level-v1.mq4 |
//|                                                       Rod Barias |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Rod Barias"
#property link      "http://www.metaquotes.net"

extern string NOTE ="THIS EA IS SET ONLY ON M1 TIME FRAME";
extern int period = 20;                           // initial level
extern int ma_shift = 2;
extern int shift = 0;
extern double step = 0.02;
extern double maximum = 0.2;
extern int Percent = 80;                          // percent of risk
extern int slippage = 6;                          // Maximum price slippage for buy or sell orders.
extern int stoploss = 500;                        // Stop loss
extern int takeprofit = 500;                      // Take profit
extern double Profit = 3;                         // Desired profit
extern double LossProfit = 10;                    // Loss profit
extern int MaxOrder = 10;                         // max total order to process
extern int start_hour = 1;                        // time to start trade
extern int end_hour = 23;                         // time to end trade
extern datetime DateBegin = D'2013.03.18';        // date to start trade
extern datetime DateStop = D'2013.03.23';         // date to stop trade
bool Work=true;                                   // EA will work
 int sell;
 int buy;
 int Ticket;                                      // number of selected order
 double SL;
 double TP;
 double Profit_T;                                 // profit for every trade
 int magic=5121981;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(IsTradeAllowed()) Print("Trade allowed");
   if(IsDemo()) Print("I work at a demo account");
    else Print("I work at a real account");    
   return(0);
   sell=0;
   buy=0;
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  string symb = Symbol();
  
  //----------TECHNICAL INDICATOR PROCESS-----------
  
  double MA=iMA(symb,PERIOD_M1,period,ma_shift,MODE_EMA,PRICE_CLOSE,shift);
  
  double ma=iSAR(symb,PERIOD_M1,step,maximum,shift);
  if(Bid>ma) {buy++; sell=0;}
  if(buy>=10) buy=0;
  if(Bid<ma) {sell++; buy=0;}
  if(sell>=10) sell=0;
  
//-------------FOR CLOSING ORDER -------------------

  for (int i=0; i<OrdersTotal(); i++)
  {if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
    {if (!OrderMagicNumber()==magic && !OrderSymbol()==symb) continue;
       {
        Ticket=OrderTicket();
        if (sell>2 && Bid>MA && Bid<Close[2])
          {if (OrderType()==OP_BUY) OrderClose(Ticket,OrderLots(),Bid,slippage,DimGray);}
        if (buy>2 && Bid<MA && Bid>Close[2])
          {if (OrderType()==OP_SELL) OrderClose(Ticket,OrderLots(),Ask,slippage,DimGray);}
       }
    }
  }
  close();

//+-------------COMPUTING LOTS ----------------------

  if (Bid<10)
    {int Points=10000;}
  else
    {Points=100;}
  RefreshRates();
  double Lts=OrderLots();
  int Free = AccountFreeMargin();                         // free margin
  Lts=NormalizeDouble(Free*Percent/100/Bid/Points,2); // lots for ordering
  if (Lts<=0) return(0);                // processing errors
  double  lot=MarketInfo(symb,MODE_MAXLOT);
  if (Lts>lot) Lts=lot;
  int TotalOrder=MaxOrder;

//+--------------TIME & DATE TO START ----------------
  
  string day=TimeToStr(TimeCurrent(), TIME_DATE);
  datetime today=StrToTime(day);
  int dateB=TimeDay(DateBegin);
  int dateS=TimeDay(DateStop);
  if(Day()<dateB) return;
  if(Day()>dateS) return;
  if(today!=DateBegin) TotalOrder=MaxOrder;
    
  string x=TimeToStr(TimeCurrent(), TIME_MINUTES);
  datetime d=StrToTime(x);
  int time=TimeHour(d);
  if (time>=start_hour)
  {

//-------------- ORDERING MODE -----------------------

  if (time>=end_hour-1) TotalOrder=0;
  if (TotalOrder>0)
   {if (TotalOrder<=OrdersTotal()) return(0);
    Ticket=OrderTicket();                       
    if (buy>1 && Bid<MA && Bid>Close[2])
     {
       RefreshRates();       
       Ticket=OrderSend(symb,OP_BUY,Lts,Ask,slippage,0,0,NULL,magic,0,MediumBlue);       // Open Buy
       if (Ticket>0) return(0);                     
     }  
    if (sell>1 && Bid>MA && Bid<Close[2])                              
     { 
       RefreshRates();           
       Ticket=OrderSend(symb,OP_SELL,Lts,Bid,slippage,0,0,NULL,magic,0,Crimson);      // Open Sell
       if (Ticket>0) return(0);
     }
    if (Errors(GetLastError())==1) return(0);
   }
  }   
//---
  return(0);
  }

//--------------PROCESSING ERROR ---------------------

bool Errors(int Error)                            // function of processing errors
 {
  if(Error==0)
      return(false);                             // No error
  switch(Error)
    {
    //---- codes returned from trade server
      case 0:
      case 1:   RefreshRates(); break; // "no error"
      case 2:   return(0); // "common error"
      case 3:   return(0); // "invalid trade parameters"
      case 4:   Sleep(3000); return(0); // "trade server is busy"
      case 5:   Work=false; return(0); // "old version of the client terminal"
      case 6:   return(0); // "no connection with trade server"
      case 7:   return(0); // "not enough rights"
      case 8:   return(0); // "too frequent requests"
      case 9:   return(0); // "malfunctional trade operation"
      case 64:  Work=false; return(0); // "account disabled"
      case 65:  return(0); // "invalid account"
      case 128: return(0); // "trade timeout"
      case 129: RefreshRates(); return(0); // "invalid price"
      case 130: return(0); // "invalid stops"
      case 131: RefreshRates(); return(0); // "invalid trade volume"
      case 132: return(0); // "market is closed"
      case 133: return(0); // "trade is disabled"
      case 134: return(0); // "not enough money"
      case 135: RefreshRates(); return(0); // "price changed"
      case 136: while (RefreshRates()==false) Sleep(10); modify(); // "off quotes"
      case 137: Sleep(500); return(0); // "broker is busy"
      case 138: RefreshRates(); return(0); // "requote"
      case 139: return(0); // "order is locked"
      case 140: return(0); // "long positions only allowed"
      case 141: return(0); // "too many requests"
      case 145: return(0); // "modification denied because order too close to market"
      case 146: Sleep(500); return(0); // "trade context is busy"
      case 148: break;     // The amount of open and pending orders has reached the limit set by the broker.
      case 149: break;     // An attempt to open a position opposite to the existing one when hedging is disabled.
      case 150: break;     // An attempt to close a position contravening the FIFO rule.
      //---- mql4 errors
      case 4000: return(0); // "no error"
      case 4001: return(0); // "wrong function pointer"
      case 4002: return(0); // "array index is out of range"
      case 4003: break;     // "no memory for function call stack"
      case 4004: break;     // "recursive stack overflow"
      case 4005: break;     // "not enough stack for parameter"
      case 4006: break;     // "no memory for parameter string"
      case 4007: break;     // "no memory for temp string"
      case 4008: break;     // "not initialized string"
      case 4009: return(0); // "not initialized string in array"
      case 4010: return(0); // "no memory for array\' string"
      case 4011: return(0); // "too long string"
      case 4012: return(0); // "remainder from zero divide"
      case 4013: return(0); // "zero divide"
      case 4014: return(0); // "unknown command"
      case 4015: return(0); // "wrong jump (never generated error)"
      case 4016: return(0); // "not initialized array"
      case 4017: return(0); // "dll calls are not allowed"
      case 4018: return(0); // "cannot load library"
      case 4019: return(0); // "cannot call function"
      case 4020: return(0); // "expert function calls are not allowed"
      case 4021: return(0); // "not enough memory for temp string returned from function"
      case 4022: return(0); // "system is busy (never generated error)"
      case 4050: return(0); // "invalid function parameters count"
      case 4051: return(0); // "invalid function parameter value"
      case 4052: return(0); // "string function internal error"
      case 4053: return(0); // "some array error"
      case 4054: return(0); // "incorrect series array using"
      case 4055: return(0); // "custom indicator error"
      case 4056: return(0); // "arrays are incompatible"
      case 4057: return(0); // "global variables processing error"
      case 4058: return(0); // "global variable not found"
      case 4059: return(0); // "function is not allowed in testing mode"
      case 4060: return(0); // "function is not confirmed"
      case 4061: return(0); // "send mail error"
      case 4062: return(0); // "string parameter expected"
      case 4063: return(0); // "integer parameter expected"
      case 4064: return(0); // "double parameter expected"
      case 4065: return(0); // "array as parameter expected"
      case 4066: return(0); // "requested history data in update state"
      case 4099: return(0); // "end of file"
      case 4100: return(0); // "some file error"
      case 4101: return(0); // "wrong file name"
      case 4102: return(0); // "too many opened files"
      case 4103: return(0); // "cannot open file"
      case 4104: return(0); // "incompatible access to a file"
      case 4105: return(0); // "no order selected"
      case 4106: return(0); // "unknown symbol"
      case 4107: return(0); // "invalid price parameter for trade function"
      case 4108: RefreshRates(); return(0); // "invalid ticket"
      case 4109: return(0); // "trade is not allowed"
      case 4110: return(0); // "longs are not allowed"
      case 4111: return(0); // "shorts are not allowed"
      case 4200: return(0); // "object is already exist"
      case 4201: return(0); // "unknown object property"
      case 4202: return(0); // "object is not exist"
      case 4203: return(0); // "unknown object type"
      case 4204: return(0); // "no object name"
      case 4205: return(0); // "object coordinates error"
      case 4206: return(0); // "no specified subwindow"
      default:   return(0); // "unknown error";
    }
  }

//------ ANOTHER CLOSING PROCESS --------------------

int close()
 {
  string x=TimeToStr(TimeCurrent(), TIME_MINUTES);
  datetime d=StrToTime(x);
  int time=TimeHour(d);
  string symb = Symbol();  
  for (int i=0; i<OrdersTotal(); i++)
  {if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
    {if (!OrderMagicNumber()==magic && !OrderSymbol()==symb) continue;
     Ticket=OrderTicket();
     Profit_T = OrderProfit()+OrderCommission()+OrderSwap();
     if (Profit_T>=Profit || Profit_T<=-LossProfit)
       {if (OrderType()==OP_BUY) OrderClose(Ticket,OrderLots(),Bid,slippage,DimGray);
        if (OrderType()==OP_SELL) OrderClose(Ticket,OrderLots(),Ask,slippage,DimGray);}
     if(time>=end_hour)
       {if (OrderType()==OP_BUY) OrderClose(Ticket,OrderLots(),Bid,slippage,Gold);
        if (OrderType()==OP_SELL) OrderClose(Ticket,OrderLots(),Ask,slippage,Gold);}
    }
   if (Errors(GetLastError())==1) return(0);
  }
 }

//--------- MODIFYING ORDERS -------------------------

int modify()
  {
  if (Bid<10)
    int digit=5;
  else
    digit=3;

  for (int i=0; i<OrdersTotal(); i++)
  {if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
    {Ticket=OrderTicket();                                        
     SL = OrderStopLoss();
     TP = OrderTakeProfit();
     if (OrderType()==OP_BUY)
      {SL = NormalizeDouble(Ask-stoploss*Point,digit);
       TP = NormalizeDouble(Ask+takeprofit*Point,digit);
       OrderModify(Ticket,OrderOpenPrice(),SL,TP,0);
      }
     if (OrderType()==OP_SELL)
      {SL = NormalizeDouble(Bid+stoploss*Point,digit);
       TP = NormalizeDouble(Bid-takeprofit*Point,digit);
       OrderModify(Ticket,OrderOpenPrice(),SL,TP,0);
      }
     else
     if (Errors(GetLastError())==1) return(0);}}
  }
 
//----------------------------------------------------
  